classification
Title: Reader of BufferedRWPair is not closed if writer's close() fails
Type: behavior Stage: resolved
Components: IO Versions: Python 3.5, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: serhiy.storchaka Nosy List: benjamin.peterson, martin.panter, pitrou, python-dev, serhiy.storchaka, stutzbach
Priority: normal Keywords: patch

Created on 2014-06-18 17:52 by serhiy.storchaka, last changed 2015-03-24 21:24 by serhiy.storchaka. This issue is now closed.

Files
File name Uploaded Description Edit
bufferedrwpair_close.patch serhiy.storchaka, 2014-06-18 17:52 review
bufferedrwpair_close_2.patch serhiy.storchaka, 2014-11-25 07:41 review
Messages (6)
msg220945 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-06-18 17:52
Current implementation of BufferedRWPair.close() is:

    def close(self):
        self.writer.close()
        self.reader.close()

When self.writer.close() raises an exception, self.reader left non-closed. This can cause file description leak unless GC sweep it.

Proposed patch fixes this issue. With applied patch for issue21715 it would be a little simpler.
msg224000 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-07-25 20:47
Antoine, what do you think about this?
msg231595 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-11-24 10:00
Why don't you reuse the API from issue21715?
msg231641 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-11-25 07:41
Because this API was not still committed. Here is a patch which uses it.
msg234268 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2015-01-18 20:05
Ping.

If this patch will be accepted I'll provide larger patch for similar issues in close methods of other classes.
msg239182 - (view) Author: Roundup Robot (python-dev) Date: 2015-03-24 21:24
New changeset d4694c672c36 by Serhiy Storchaka in branch '3.4':
Issue #21802: The reader in BufferedRWPair now is closed even when closing
https://hg.python.org/cpython/rev/d4694c672c36

New changeset f515c7ccff57 by Serhiy Storchaka in branch 'default':
Issue #21802: The reader in BufferedRWPair now is closed even when closing
https://hg.python.org/cpython/rev/f515c7ccff57

New changeset dcf25060cae8 by Serhiy Storchaka in branch '2.7':
Issue #21802: The reader in BufferedRWPair now is closed even when closing
https://hg.python.org/cpython/rev/dcf25060cae8
History
Date User Action Args
2015-03-24 21:24:54serhiy.storchakasetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2015-03-24 21:24:33python-devsetnosy: + python-dev
messages: + msg239182
2015-03-24 21:01:59serhiy.storchakasetassignee: serhiy.storchaka
2015-03-20 02:47:50martin.pantersetnosy: + martin.panter
2015-01-18 20:05:49serhiy.storchakasetmessages: + msg234268
2014-11-25 07:41:18serhiy.storchakasetfiles: + bufferedrwpair_close_2.patch

messages: + msg231641
2014-11-24 10:00:20pitrousetmessages: + msg231595
2014-07-25 20:47:34serhiy.storchakasetmessages: + msg224000
2014-06-18 17:52:22serhiy.storchakacreate